Index: /stable/HeuristicLab 3.3 Tests.vsmdi
===================================================================
--- /stable/HeuristicLab 3.3 Tests.vsmdi	(revision 9884)
+++ /stable/HeuristicLab 3.3 Tests.vsmdi	(revision 9885)
@@ -47,15 +57,16 @@
     <Description>This should be run whenever a new plugin is added or a plugin dependency or an assembly reference is added, updated, or deleted.</Description>
     <TestLinks>
-      <TestLink id="0b6f54a2-1543-af9f-b604-0640ef177083" name="BuildTypeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="ec4d1ddf-ed6b-9f9e-29a0-d9e558856af1" name="ContentViewAttributeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="202601a9-803a-67b8-a9d5-01dee0738a98" name="InstantiateAllCreatables" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="388c8c97-aaeb-a5f1-f695-656925a69975" name="TestParameterVisibility" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="c895df0c-4700-c067-97e4-6bbde15397a5" name="IsSubTypeOfTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="29ead60b-2ae7-821a-ccc3-e5e4769661b7" name="TestStorableConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="36916402-ba0c-751d-366b-380dac87dcef" name="CheckPluginDependenciesForReferencedAssemblies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="3983eb26-fd15-5b88-1fd7-07b363511b10" name="TestCloningConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="2028e687-d144-bb6f-bb05-ac86eaec07ee" name="TestCloningAllDeepCloneables" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="34ed65f1-46f7-d2e6-64cc-c2d958294d8b" name="CheckReferenceAssembliesForPluginDependencies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
-      <TestLink id="16b2cf1b-19e9-1b71-7f66-2744c23017a0" name="TestToString" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="715a0741-e8c1-ea5c-5a6f-fbbae30e95a8" name="InstantiateAllCreatables" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="504d733a-e966-67b0-0ba8-3b4888281cf4" name="TestStorableConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="cc872b4f-4e35-33c8-8289-5a4cf3cbbce6" name="TestToString" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="0ce573f2-91a8-3077-eecc-904f97bdb9c0" name="TestCloningAllDeepCloneables" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="5b2c47f1-9468-ac34-8edd-f59a7c139445" name="CheckReferenceAssembliesForPluginDependencies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="d97af6e5-d9b9-5659-4bed-f5dc07ae803c" name="CollectGASample" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="ee3fccd7-766b-ab66-eb4d-f99fb11310a3" name="TestCloningConstructor" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="9c0cdbd0-5ad5-51ee-cae0-8fad5012ea71" name="IsSubTypeOfTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="55966e1d-fca8-fba9-a841-59c773f773c7" name="TestParameterVisibility" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="ebcbe255-075f-7ef2-c6e4-8c22202e1c7a" name="BuildTypeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="3df6f9a5-55f4-db76-f0c1-f49377067ea8" name="ContentViewAttributeTest" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
+      <TestLink id="bf0dd0b1-2095-ee2b-0e5a-270d61f3e645" name="CheckPluginDependenciesForReferencedAssemblies" storage="heuristiclab.tests\bin\heuristiclab.tests.dll" type="Microsoft.VisualStudio.TestTools.TestTypes.Unit.UnitTestElement, Microsoft.VisualStudio.QualityTools.Tips.UnitTest.ObjectModel, Version=10.0.0.0, Culture=neutral, PublicKeyToken=b03f5f7f11d50a3a" />
     </TestLinks>
   </TestList>
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/AlgorithmExtensions.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/AlgorithmExtensions.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/AlgorithmExtensions.cs	(revision 9885)
@@ -25,5 +25,5 @@
 using HeuristicLab.Core;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   public static class AlgorithmExtensions {
     public static void StartSync(this IExecutable executable, CancellationToken cancellationToken) {
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/CloningConstructorTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/CloningConstructorTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/CloningConstructorTest.cs	(revision 9885)
@@ -28,5 +28,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class CloningConstructorTest {
@@ -38,4 +38,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "medium")]
     public void TestCloningConstructor() {
       StringBuilder errorMessage = new StringBuilder();
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/CollectObjectGraphTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/CollectObjectGraphTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/CollectObjectGraphTest.cs	(revision 9885)
@@ -31,8 +31,7 @@
 using HeuristicLab.Persistence.Default.Xml;
 using HeuristicLab.Problems.TestFunctions;
-using HeuristicLab.SequentialEngine;
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class CollectObjectGraphTest {
@@ -45,4 +44,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "medium")]
     [DeploymentItem(@"HeuristicLab-3.3/Resources/GA_SymbReg.hl")]
     public void CollectGASample() {
@@ -95,4 +97,6 @@
     /// </summary>
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "long")]
     public void AlgorithmExecutions() {
       var algs = new List<IAlgorithm>();
@@ -103,5 +107,5 @@
         ga.PopulationSize.Value = 5;
         ga.MaximumGenerations.Value = 5;
-        ga.Engine = new SequentialEngine();
+        ga.Engine = new SequentialEngine.SequentialEngine();
         ga.Problem = new SingleObjectiveTestFunctionProblem();
 
@@ -121,4 +125,6 @@
     /// </summary>
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "medium")]
     public void ParallelAlgorithmExecutions() {
       int n = 60;
@@ -133,5 +139,5 @@
           ga.PopulationSize.Value = 5;
           ga.MaximumGenerations.Value = 5;
-          ga.Engine = new SequentialEngine();
+          ga.Engine = new SequentialEngine.SequentialEngine();
           ga.Problem = new SingleObjectiveTestFunctionProblem();
           ga.Prepare(true);
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/ContentViewTests.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/ContentViewTests.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/ContentViewTests.cs	(revision 9885)
@@ -28,23 +28,8 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class ContentViewTests {
     public ContentViewTests() {
-    }
-
-    private TestContext testContextInstance;
-
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
     }
 
@@ -57,4 +42,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "long")]
     public void ContentViewAttributeTest() {
       //get all non-generic and instantiable classes which implement IContentView
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/DeepCloneableCloningTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/DeepCloneableCloningTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/DeepCloneableCloningTest.cs	(revision 9885)
@@ -30,5 +30,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   /// <summary>
   /// Summary description for DeepCloneableCloningTest
@@ -40,4 +40,10 @@
     public static void MyClassInitialize(TestContext testContext) {
       PluginLoader.Assemblies.Any();
+    }
+
+    private TestContext testContextInstance;
+    public TestContext TestContext {
+      get { return testContextInstance; }
+      set { testContextInstance = value; }
     }
 
@@ -55,43 +61,10 @@
     }
 
-    private TestContext testContextInstance;
     private readonly HashSet<Type> excludedTypes;
 
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
-    public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
-    }
-
-    #region Additional test attributes
-    //
-    // You can use the following additional attributes as you write your tests:
-    //
-    // Use ClassInitialize to run code before running the first test in the class
-    // [ClassInitialize()]
-    // public static void MyClassInitialize(TestContext testContext) { }
-    //
-    // Use ClassCleanup to run code after all tests in a class have run
-    // [ClassCleanup()]
-    // public static void MyClassCleanup() { }
-    //
-    // Use TestInitialize to run code before running each test 
-    // [TestInitialize()]
-    // public void MyTestInitialize() { }
-    //
-    // Use TestCleanup to run code after each test has run
-    // [TestCleanup()]
-    // public void MyTestCleanup() { }
-    //
-    #endregion
-
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "long")]
     [DeploymentItem(@"HeuristicLab-3.3\Resources\SamplesExperimentFinished.hl")]
     public void TestCloningFinishedExperiment() {
@@ -105,4 +78,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "long")]
     public void TestCloningAllDeepCloneables() {
       PluginLoader.Assemblies.ToArray();
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/GeneticAlgorithmTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/GeneticAlgorithmTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/GeneticAlgorithmTest.cs	(revision 9885)
@@ -28,5 +28,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class GeneticAlgorithmTest {
@@ -34,39 +34,8 @@
 
     private TestContext testContextInstance;
-
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
     public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
+      get { return testContextInstance; }
+      set { testContextInstance = value; }
     }
-
-    #region Additional test attributes
-    //
-    // You can use the following additional attributes as you write your tests:
-    //
-    // Use ClassInitialize to run code before running the first test in the class
-    // [ClassInitialize()]
-    // public static void MyClassInitialize(TestContext testContext) { }
-    //
-    // Use ClassCleanup to run code after all tests in a class have run
-    // [ClassCleanup()]
-    // public static void MyClassCleanup() { }
-    //
-    // Use TestInitialize to run code before running each test 
-    // [TestInitialize()]
-    // public void MyTestInitialize() { }
-    //
-    // Use TestCleanup to run code after each test has run
-    // [TestCleanup()]
-    // public void MyTestCleanup() { }
-    //
-    #endregion
 
     private EventWaitHandle trigger = new AutoResetEvent(false);
@@ -74,4 +43,6 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestProperty("Time", "long")]
     [DeploymentItem(@"HeuristicLab-3.3/Resources/GA_TSP.hl")]
     public void GeneticAlgorithmPerformanceTest() {
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/InstantiateCreatablesTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/InstantiateCreatablesTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/InstantiateCreatablesTest.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
 
   [TestClass]
@@ -37,4 +37,7 @@
     }
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "medium")]
     public void InstantiateAllCreatables() {
       var exceptions = new List<string>();
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/ParameterVisibilityTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/ParameterVisibilityTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/ParameterVisibilityTest.cs	(revision 9885)
@@ -28,5 +28,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class ParameterVisibilityTest {
@@ -36,19 +36,15 @@
       PluginLoader.Assemblies.Any();
     }
-    /// <summary>
-    ///Gets or sets the test context which provides
-    ///information about and functionality for the current test run.
-    ///</summary>
+
     private TestContext testContextInstance;
     public TestContext TestContext {
-      get {
-        return testContextInstance;
-      }
-      set {
-        testContextInstance = value;
-      }
+      get { return testContextInstance; }
+      set { testContextInstance = value; }
     }
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "long")]
     public void TestParameterVisibility() {
       StringBuilder errorMessage = new StringBuilder();
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/PluginDependenciesTest.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/PluginDependenciesTest.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/PluginDependenciesTest.cs	(revision 9885)
@@ -29,5 +29,5 @@
 using Microsoft.VisualStudio.TestTools.UnitTesting;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   [TestClass]
   public class PluginDependenciesTest {
@@ -53,4 +53,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "short")]
     public void CheckReferenceAssembliesForPluginDependencies() {
       StringBuilder errorMessage = new StringBuilder();
@@ -76,4 +79,7 @@
 
     [TestMethod]
+    [TestCategory("General")]
+    [TestCategory("Essential")]
+    [TestProperty("Time", "short")]
     public void CheckPluginDependenciesForReferencedAssemblies() {
       StringBuilder errorMessage = new StringBuilder();
@@ -103,5 +109,5 @@
 
     private static Type GetPluginFromAssembly(Assembly assembly) {
-      return assembly.GetExportedTypes().Where(t => typeof(IPlugin).IsAssignableFrom(t) && !t.IsAbstract && !t.IsInterface).FirstOrDefault();
+      return assembly.GetExportedTypes().FirstOrDefault(t => typeof(IPlugin).IsAssignableFrom(t) && !t.IsAbstract && !t.IsInterface);
     }
 
Index: /stable/HeuristicLab.Tests/HeuristicLab-3.3/PluginLoader.cs
===================================================================
--- /stable/HeuristicLab.Tests/HeuristicLab-3.3/PluginLoader.cs	(revision 9884)
+++ /stable/HeuristicLab.Tests/HeuristicLab-3.3/PluginLoader.cs	(revision 9885)
@@ -27,5 +27,5 @@
 using HeuristicLab.PluginInfrastructure;
 
-namespace HeuristicLab_33.Tests {
+namespace HeuristicLab.Tests {
   public static class PluginLoader {
     public const string ExecutableExtension = ".exe";
@@ -36,9 +36,8 @@
 
     static PluginLoader() {
-      foreach (string path in Directory.EnumerateFiles(Environment.CurrentDirectory).Where(IsRelevantAssemblyPath)) {
+      foreach (string path in Directory.EnumerateFiles(AppDomain.CurrentDomain.BaseDirectory).Where(IsRelevantAssemblyPath)) {
         try {
           Assembly.LoadFrom(path);
-        }
-        catch (BadImageFormatException) { }
+        } catch (BadImageFormatException) { }
       }
       // test relevant path again to exclude previously loaded assemblies
